# -*- coding: utf-8 -*-
import socket
from PIL import ImageGrab
import base64
import glob
import os
import shutil
import subprocess


def functions(data, client_socket):
    """
    Input: 4 digit functions
    output: different things according to the function entered
    """
    while True:
        if data == "SNIP":
            # takes a screenshot of the client screen and
            # sends it to the client
            im = ImageGrab.grab()
            im.save(r'E:\11th_Grade\Python\Socket_Q2.7\Server_Screen.png')
            with open(r'E:\11th_Grade\Python\Socket_Q2.7\Server_Screen.png',
                      "rb") as imageFile:
                img_str = base64.b64encode(imageFile.read())
                for i in xrange(0, len(img_str) - 1000, 1000):
                    client_socket.send(img_str[i:i+1000])
                client_socket.send(img_str[i + 1000:] + " END")
            os.remove(r'E:\11th_Grade\Python\Socket_Q2.7\Server_Screen.png')

        elif data == "FILE":
            # sends the client the directories of all the
            # files in this folder
            length = client_socket.recv(4)
            path = client_socket.recv(int(length))
            is_exist = os.path.exists(path)
            if is_exist:
                files_list = glob.glob(path + "\*.*")
                client_socket.send(str(len(files_list)))  # sends length of
                for i in files_list:                      # the list
                    client_socket.send("{:0>4}".format(len(i))+i)

        elif data == "DELT":
            # removes the file in the directory given by he
            # client
            length = client_socket.recv(4)
            path = client_socket.recv(int(length))
            is_exist = os.path.exists(path)
            if is_exist:
                os.remove(path)
                client_socket.send("suc")  # success
            else:
                client_socket.send("err")  # error

        elif data == "COPY":
            # copies the content of one file to another
            length1 = client_socket.recv(4)
            path1 = client_socket.recv(int(length1))
            is_exist1 = os.path.exists(path1)
            length2 = client_socket.recv(4)
            path2 = client_socket.recv(int(length2))
            is_exist2 = os.path.exists(path2)
            if is_exist1 and is_exist2:
                shutil.copy(path1, path2)
                client_socket.send("suc")  # success
            elif (not is_exist1) and (not is_exist2):
                client_socket.send("err")  # error

        elif data == "OPEN":
            # opens the app received by the client
            length = client_socket.recv(4)
            path = client_socket.recv(int(length))
            try:
                subprocess.call(path)
                client_socket.send("suc")  # success
            except:
                client_socket.send("err")  # error

        elif data != "EXIT":
            client_socket.send("Error. Enter a proper function")
        data = client_socket.recv(1000)


def main():
    """
    Accepts the client and does the functions it requests
    """
    server_socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    server_socket.bind(("0.0.0.0", 1729))  # broadcast ip, open port on this pc
    server_socket.listen(1)
    while True:
        try:
            client_socket, address = server_socket.accept()
            data = client_socket.recv(1000)
            functions(data, client_socket)
        except socket.error:
            print "client disconnected"


if __name__ == '__main__':
    main()
